Imports Microsoft.VisualBasic

Namespace Pentabyte.WebControls

    Public Class ScrambledEmailLink
        Inherits System.Web.UI.WebControls.WebControl

        Private _Email As String = ""
        Private _Subject As String = ""
        Private _DisplayText As String = ""

        Public Property Email() As String
            Get
                Return _Email
            End Get
            Set(ByVal Value As String)
                _Email = Value
            End Set
        End Property

        Public Property Subject() As String
            Get
                Return _Subject
            End Get
            Set(ByVal Value As String)
                _Subject = Value
            End Set
        End Property

        Public Property DisplayText() As String
            Get
                Return _DisplayText
            End Get
            Set(ByVal Value As String)
                _DisplayText = Value
            End Set
        End Property

        Protected Overrides Sub Render(ByVal writer As System.Web.UI.HtmlTextWriter)
            Dim link As String = _Email
            Dim display As String = _DisplayText
            If display = "" Then display = _Email
            If (_Subject <> "") Then link = link & "?subject=" & System.Web.HttpContext.Current.Server.UrlEncode(_Subject)
            writer.write(encode("<a href=""mailto:" & link & """>" & display & "</a>"))
        End Sub

        Private Function encode(ByVal x As String) As String
            If Not x Is Nothing Then
                Dim html As String = "<script type=""text/javascript"">"
                Dim c As Char
                For Each c In x
                    html = html & "document.write('" & c & "');"
                Next
                html = html & "<" & "/script>"
                Return html
            Else
                Return ""
            End If
        End Function

    End Class

End Namespace
